<template>
  <Dialog :title="dialogTitle" v-model="dialogVisible">
    <el-form
      ref="formRef"
      :model="formData"
      :rules="formRules"
      label-width="100px"
      v-loading="formLoading"
    >
      <el-form-item :label="t('chooseMaintain.materialCode')" prop="materialCode">
        <el-input v-model="formData.materialCode" :placeholder="t('chooseMaintain.materialCode')" disabled/>
      </el-form-item>
      <el-form-item :label="t('chooseMaintain.materialName')" prop="materialName">
        <el-input v-model="formData.materialName" :placeholder="t('chooseMaintain.materialName')" disabled/>
      </el-form-item>
      <el-form-item :label="t('route.quantity')" prop="quantity">
        <el-input v-model="formData.quantity" :placeholder="t('route.quantity')" disabled/>
      </el-form-item>
      <el-form-item :label="t('workOrderMaterial.unitPrice')" prop="unitPrice">
        <el-input v-model="formData.unitPrice" :placeholder="t('workOrderMaterial.unitPrice')" disabled/>
      </el-form-item>
      <el-form-item :label="t('workOrderMaterial.unit')" prop="unit">
        <el-input v-model="formData.unit" :placeholder="t('workOrderMaterial.unit')" disabled/>
      </el-form-item>
      <el-form-item :label="t('route.safetyStock')" prop="safetyStock">
        <el-input v-model="formData.safetyStock" :placeholder="t('route.safetyStock')" />
      </el-form-item>
      <el-form-item :label="t('bomList.sort')" prop="sort">
        <el-input-number v-model="formData.sort" :min="0" controls-position="right" />
      </el-form-item>
      <el-form-item :label="t('form.remark')" prop="remark">
        <el-input v-model="formData.remark" :placeholder="t('form.remark')" />
      </el-form-item>
    </el-form>
    <template #footer>
      <el-button @click="submitForm" type="primary" :disabled="formLoading">{{ t('operationFillForm.confirm') }}</el-button>
      <el-button @click="dialogVisible = false">{{ t('operationFillForm.cancel') }}</el-button>
    </template>
  </Dialog>
</template>
<script setup lang="ts">
import { IotSapStockApi, IotSapStockVO } from '@/api/pms/iotsapstock'

/** PMS SAP 库存(通用库存/项目部库存) 表单 */
defineOptions({ name: 'IotSapStockForm' })

const { t } = useI18n() // 国际化
const message = useMessage() // 消息弹窗

const dialogVisible = ref(false) // 弹窗的是否展示
const dialogTitle = ref('') // 弹窗的标题
const formLoading = ref(false) // 表单的加载中：1）修改时的数据加载；2）提交的按钮禁用
const formType = ref('') // 表单的类型：create - 新增；update - 修改
const formData = ref({
  id: undefined,
  deptId: undefined,
  factory: undefined,
  projectDepartment: undefined,
  materialCode: undefined,
  materialName: undefined,
  materialGroupName: undefined,
  materialGroupId: undefined,
  quantity: undefined,
  unitPrice: undefined,
  unit: undefined,
  safetyStock: undefined,
  shelvesId: undefined,
  cargoLocationId: undefined,
  type: undefined,
  syncStatus: undefined,
  syncTime: undefined,
  syncError: undefined,
  sort: undefined,
  status: undefined,
  remark: undefined,
})
const formRules = reactive({
  safetyStock: [{
    pattern: /^(?!-)\d+(\.\d+)?$/,
    message: '安全库存必须为非负小数',
    trigger: 'blur'
  }]
})
const formRef = ref() // 表单 Ref

/** 打开弹窗 */
const open = async (type: string, id?: number) => {
  dialogVisible.value = true
  dialogTitle.value = t('action.' + type)
  formType.value = type
  resetForm()
  // 修改时，设置数据
  if (id) {
    formLoading.value = true
    try {
      formData.value = await IotSapStockApi.getIotSapStock(id)
    } finally {
      formLoading.value = false
    }
  }
}
defineExpose({ open }) // 提供 open 方法，用于打开弹窗

/** 提交表单 */
const emit = defineEmits(['success']) // 定义 success 事件，用于操作成功后的回调
const submitForm = async () => {
  // 校验表单
  await formRef.value.validate()
  // 提交请求
  formLoading.value = true
  try {
    const data = formData.value as unknown as IotSapStockVO
    if (formType.value === 'create') {
      await IotSapStockApi.createIotSapStock(data)
      message.success(t('common.createSuccess'))
    } else {
      await IotSapStockApi.updateIotSapStock(data)
      message.success(t('common.updateSuccess'))
    }
    dialogVisible.value = false
    // 发送操作成功的事件
    emit('success')
  } finally {
    formLoading.value = false
  }
}

/** 重置表单 */
const resetForm = () => {
  formData.value = {
    id: undefined,
    deptId: undefined,
    factory: undefined,
    projectDepartment: undefined,
    materialCode: undefined,
    materialName: undefined,
    materialGroupName: undefined,
    materialGroupId: undefined,
    quantity: undefined,
    unitPrice: undefined,
    unit: undefined,
    safetyStock: undefined,
    shelvesId: undefined,
    cargoLocationId: undefined,
    type: undefined,
    syncStatus: undefined,
    syncTime: undefined,
    syncError: undefined,
    sort: undefined,
    status: undefined,
    remark: undefined,
  }
  formRef.value?.resetFields()
}
</script>
